package StarcityClient;

import java.io.*;
import java.net.*;

/**
  * Thread che si occupa di ricevere i messaggi
  */

public class Ricevi extends Thread {
  protected BufferedReader  bufferedReader;
  protected Socket          clientSock;
  private   boolean         ricevuto = false;

  public Ricevi(BufferedReader bufferedReader, Socket clientSock) throws IOException  {
    super();
    this.bufferedReader = bufferedReader;
    this.clientSock = clientSock;
    bufferedReader = new BufferedReader(new InputStreamReader(clientSock.getInputStream()));
  }

/**
  * Gestisce lo stream di input bufferizzando i messaggi che arrivano e passandoli
  * al protocollo che li elaborer
  */
  public void run() {
    while (ricevuto)  {
      ricevuto = false;
    }
  }

  public String riceviMSG ()  {
    String Messaggio = "";
    try {
      Messaggio = bufferedReader.readLine();
    }
    catch (IOException e) {}
    ricevuto = true;
    return Messaggio;
  }

}
