package StarcityServer;

import java.io.*;
import java.net.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;

/**
  * Implementa il protocollo di comunicazione tra i vari client e server.
  */

public class ServerStdProtocol {

  public int            serverNumPort;
  public int            clientNumPort;
  public static int     numServer;
  public int            portServAddr;
  public Socket         clientSock;
  public String         ipServerAddr;
  public ServerSocket   listenServer;
  public ServerSocket   listenClient;
  public ListenClient   clientListener;
  public ListenServer   serverListener;
  public String           ipServAddr;
  public ComServerServer  comServerServer;
  public ComServer        comServer;
  public String           messaggio = "";
  protected static String address = "localhost";
  protected int           portnum;
  public    Connection    connection;


//---------------------------------------------------------------------------

/**
  * Rende attive le porte di ascolto del server
  */

  public ServerStdProtocol(int numServer) {
    this.numServer     = numServer;

    switch (numServer)  {
      case 1: clientNumPort = 2000;
              serverNumPort = 3000;
              break;
      case 2: clientNumPort = 2001;
              serverNumPort = 3000;
              break;
    }

    if (numServer == 1) {
      try {
        listenServer       = new ServerSocket(serverNumPort);
        serverListener     = new ListenServer (listenServer, this);
        //System.out.println("\nNumero della porta del Server1 per comunicare con il Server2: " + serverNumPort);
        serverListener.start();
      }
      catch (IOException e){}
    }

    else  {
      try {
        connection = new Connection (address, serverNumPort);
        clientSock = connection.clientSock;
        comServer = new ComServer (clientSock, this);
        //System.out.println("\nNumero della porta del Server2 per comunicare con il Server1: " + serverNumPort);
        comServer.start();
      }
      catch (IOException e) {}
    }

    try {
      listenClient       = new ServerSocket(clientNumPort);
      clientListener     = new ListenClient (listenClient, this);
      System.out.println("Numero della porta del Server per comunicare con il Client: " + clientNumPort);
      clientListener.start();
    }
    catch   (IOException e) {}

    //
    FrameServer.t1.setText("Server attivo...");
    System.out.println("\nServer attivo...");
// END
  }
//------------------------------------------------------------------------------

  public String verifica (String messaggio)  {
   this.messaggio = messaggio;
 //  System.out.println("\nSono dentro a serverStdProtocol del Server1: messaggio = " + messaggio);
    if (numServer == 1)
      return serverListener.verifica(messaggio);
    else
      return comServer.verifica(messaggio);
  }
//------------------------------------------------------------------------------

}