package StarcityClient;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import java.lang.*;
import javax.swing.border.*;

public class ClientIndexGui extends JFrame {

  int porta;
  int address;
  String indirizzo = "";
  JPanel jPanel1 = new JPanel();
  XYLayout xYLayout1 = new XYLayout();
  static JComboBox ComboSpettacolo = new JComboBox();
  JLabel jLabel1 = new JLabel();
  static JComboBox ComboSala = new JComboBox();
  JLabel jLabel2 = new JLabel();
  JButton OkBtn = new JButton();
  ClientIndexProtocol cip;
  boolean  avanti = false;
  XYLayout xYLayout2 = new XYLayout();
  JPanel jPanel2 = new JPanel();
  XYLayout xYLayout3 = new XYLayout();
  static int NUMCOLS = 15;
  static int NUMROWS = 6;
  JTextArea[][] p = new JTextArea[NUMROWS][NUMCOLS];
  JTextArea tschermo = new JTextArea();
  JButton PrenotaBtn = new JButton();
  TitledBorder titledBorder1;


/**
  * All'atto della creazione il server  rappresentato dalla posizione
  * che occupa all'interno della comboBox. Per aggiungere altri server
  * devo inserire all'interno dello switch i rispettivi indirizzi.
  */

  public ClientIndexGui(int porta, int address) {
    this.porta = porta;
    this.address = address;

    switch (address)  {
      case 1: indirizzo = "localhost";
              break;
    }

    cip = new ClientIndexProtocol(this, indirizzo, porta);
    
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try  {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }    // END constructor
//------------------------------------------------------------------------------

  private void jbInit() throws Exception  {
    titledBorder1 = new TitledBorder("");
    this.getContentPane().setLayout(xYLayout2);
    this.setTitle("Sale Cinema");

    jPanel1.setLayout(xYLayout1);
    ComboSpettacolo.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {}
    });
    jLabel1.setFont(new java.awt.Font("Monospaced", 1, 12));
    jLabel1.setText("Spettacolo:");
    jLabel2.setFont(new java.awt.Font("Monospaced", 1, 12));
    jLabel2.setText("Sala:");
    OkBtn.setFont(new java.awt.Font("Monospaced", 1, 12));
    OkBtn.setBorder(BorderFactory.createEtchedBorder());
    OkBtn.setText("Scegli");
    OkBtn.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mousePressed(MouseEvent e) {
        OkBtn_mousePressed(e);
      }
    });

    jPanel2.setLayout(xYLayout3);
    xYLayout2.setHeight(523);
    xYLayout2.setWidth(486);
    PrenotaBtn.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mousePressed(MouseEvent e) {
        PrenotaBtn_mousePressed(e);
      }
    });
    PrenotaBtn.setFont(new java.awt.Font("Monospaced", 1, 12));
    PrenotaBtn.setBorder(BorderFactory.createEtchedBorder());
    PrenotaBtn.setText("Prenota");
    this.getContentPane().add(jPanel1, new XYConstraints(0, 0, -1, -1));
    jPanel1.add(jLabel2, new XYConstraints(9, 9, 103, 16));
    jPanel1.add(ComboSala, new XYConstraints(8, 29, 117, -1));
    jPanel1.add(ComboSpettacolo, new XYConstraints(137, 29, 118, 23));
    jPanel1.add(jLabel1, new XYConstraints(137, 9, 118, 16));
    jPanel1.add(OkBtn, new XYConstraints(286, 17, 111, 38));
    this.getContentPane().add(jPanel2, new XYConstraints(4, 65, 468, 422));
    jPanel2.add(tschermo, new XYConstraints(16, 248, 382, 33));
    jPanel2.add(PrenotaBtn, new XYConstraints(138, 302, 111, 38));
    ComboSala.addItem("Sala 1");
    ComboSala.addItem("Sala 2");
    ComboSala.addItem("Sala 3");
    ComboSala.addItem("Sala 4");
    ComboSala.addItem("Sala 5");
    ComboSpettacolo.addItem("18:30");
    ComboSpettacolo.addItem("20:30");
    ComboSpettacolo.addItem("22:30");
    for (int i = 0; i < NUMROWS; i++)	{
    	for (int j = 0; j < NUMCOLS; j++)	{
        p[i][j] = new JTextArea();
    		p[i][j].setBackground(Color.lightGray);
    		p[i][j].setBorder(BorderFactory.createLineBorder(Color.black));
    		p[i][j].setEditable(false);
    		p[i][j].addMouseListener(new MouseAdapter() {
          public void mousePressed(MouseEvent e) {
            Object o = e.getSource();
            Color colorTemp =((JTextArea)o).getBackground();
          	if (colorTemp == Color.lightGray)
             	((JTextArea)o).setBackground(Color.blue);
          	else
            	((JTextArea)o).setBackground(Color.lightGray);
          }
        });
        jPanel2.add(p[i][j]);
      }
    }
    tschermo.setBackground(Color.blue);
    tschermo.setBorder(BorderFactory.createLineBorder(Color.black));
    tschermo.setText("            Schermo");
    tschermo.setEditable(false);
    tschermo.setFont(new java.awt.Font("DialogInput", 1, 20));

    this.getContentPane().add(jPanel1, BorderLayout.CENTER);
    
    for (int i = 0; i < NUMROWS; i++)	{
    	for (int j = 0; j < NUMCOLS; j++)	{
    		jPanel2.add(p[i][j], new XYConstraints(30 + 24*j, 30 + 30*i, 20, 20));
    	}
    }
    this.resize(435,450);
  }   // END init()
//------------------------------------------------------------------------------

  void OkBtn_mousePressed(MouseEvent e) {
    cip.procedi();
  }
//------------------------------------------------------------------------------

  void disegnaPostiOccupati(String posti)  {
   String row = "";
   String col = "";
   boolean found1 = false;
   boolean found2 = false;
   int rowInt = 0, colInt = 0;
   Integer temp = new Integer(0);

    for (int h = 0; h < NUMROWS; h++)
      for (int l = 0; l < NUMCOLS; l++)
        p[h][l].setBackground(Color.lightGray);

    for (int k = 0; k < posti.length(); )  {
       do {
        if (posti.charAt(k) != ' ') {
          row = row + posti.charAt(k);
        }
        else  {
          found1 = true;
        }
        k += 1;
        } while (!found1);

       do {
        if (posti.charAt(k) != ' ') {
          col = col + posti.charAt(k);
        }
        else  {
          found2 = true;
        }
        k += 1;
        } while (!found2);

        rowInt = temp.valueOf(row).intValue();
        colInt = temp.valueOf(col).intValue();
        p[rowInt][colInt].setBackground(Color.red);
        row = "";
        col = "";
        found1 = false;
        found2 = false;

    }

  }  // END disegnaPostiOccupati
//------------------------------------------------------------------------------

  public String occupa()  {
    Color c;
    String messaggio = "";
    for (int i = 0; i < NUMROWS; i++)	{
    	for (int j = 0; j < NUMCOLS; j++)	{
        c = p[i][j].getBackground();
        if (c == Color.blue)
          messaggio = messaggio + i + ' ' + j + ' ';
      }
    }
    return messaggio;
  }

  void PrenotaBtn_mousePressed(MouseEvent e) {
    cip.prenota();
  }  // END occupa
//------------------------------------------------------------------------------

}

