package StarcityServer;


import java.io.*;
import java.net.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;

public class FrameServer extends JFrame {
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  XYLayout xYLayout1 = new XYLayout();
  JButton jButton1 = new JButton();
  ServerStdProtocol serverStdProtocol;
  static JTextField t1 = new JTextField();
  static JComboBox comboNumServer = new JComboBox();
  JLabel jLabel3 = new JLabel();
  JButton DelBtn = new JButton();

  //Construct the frame
  public FrameServer() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try  {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception  {
    this.getContentPane().setLayout(borderLayout1);
    this.setSize(new Dimension(405, 135));
    this.setTitle("Frame Server");
    jPanel1.setLayout(xYLayout1);
    jButton1.setFont(new java.awt.Font("Monospaced", 1, 12));
    jButton1.setText("Run...");
    jButton1.addMouseListener(new java.awt.event.MouseAdapter() {

      public void mousePressed(MouseEvent e) {
        jButton1_mousePressed(e);
      }
    });
    jLabel3.setText("Nome Server:");
    jLabel3.setFont(new java.awt.Font("Monospaced", 0, 12));
    DelBtn.addMouseListener(new java.awt.event.MouseAdapter() {

      public void mousePressed(MouseEvent e) {
        DelBtn_mousePressed(e);
      }
    });
    DelBtn.setText("Cancella Tutto");
    DelBtn.setFont(new java.awt.Font("Monospaced", 1, 12));
    this.getContentPane().add(jPanel1, BorderLayout.CENTER);
    jPanel1.add(jButton1, new XYConstraints(276, 11, 78, -1));
    jPanel1.add(DelBtn, new XYConstraints(251, 68, 138, 31));
    jPanel1.add(jLabel3, new XYConstraints(14, 11, 87, 28));
    jPanel1.add(comboNumServer, new XYConstraints(111, 13, 123, -1));
    jPanel1.add(t1, new XYConstraints(14, 68, 221, 30));

    comboNumServer.addItem("Server 1");
    comboNumServer.addItem("Server 2");
  }

  //Overridden so we can exit on System Close
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if(e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }
//------------------------------------------------------------------------------
  void jButton1_mousePressed(MouseEvent e) {
    int numServer = comboNumServer.getSelectedIndex();
    serverStdProtocol= new ServerStdProtocol(numServer + 1);
  }

  void DelBtn_mousePressed(MouseEvent e) {
    for (int i = 1; i < 6; i++) {
      for (int j = 1; j < 4; j++) {
        try {
          FileWriter fileCL = new FileWriter ("localFiles/" + i + j + ".dat", false);
          fileCL.write("");
          FileWriter fileCLrem = new FileWriter ("remoteFiles/" + i + j + ".dat", false);
          fileCLrem.write("");
        }
        catch (IOException exc) {}
      }
    }
    t1.setText("");
    t1.setText("Ho cancellato tutti i posti.");
  }

//------------------------------------------------------------------------------
}
